<?php
  /**
   * jdownloads_search
   *
   * jDownloads search plugin for Joomla 1.6 and newer
   * by arno Betz www.jDownloads.com
   */
 
defined( '_JEXEC' ) or die( 'Restricted access' );
//Error_Reporting(E_ERROR);

jimport( 'joomla.plugin.plugin' ); 

class plgSearchJdownloads extends JPlugin
{
    
    /**
     * Constructor
     *
     * @access      protected
     * @param       object  $subject The object to observe
     * @param       array   $config  An array that holds the plugin configuration
     * @since       1.5
     */
    public function __construct(& $subject, $config)
    {
        parent::__construct($subject, $config);
        $this->loadLanguage();
    }
        
    /**
     * @return array An array of search areas
     */
    function onContentSearchAreas()
    {
        static $areas = array(
            'jdownloads' => 'PLG_SEARCH_JDOWNLOADS_JDOWNLOADS'
            );
            return $areas;
    }

  function onContentSearch($text, $phrase='', $ordering='', $areas=null) {  

  $config = JFactory::getConfig();
  $sef = $config->getValue('sef');    
  $user = &JFactory::getUser();
  $user_access = checkAccess();
  $users_access =  (int)substr($user_access, 0, 1);

  $database = &JFactory::getDBO();
  $plugin =& JPluginHelper::getPlugin('search', 'jdownloads');
  
  $plugin = JPluginHelper::getPlugin('user', 'userdirect');
  $params = new JRegistry();
  $params->loadJSON($plugin->params);
  $limit  = $params->get( 'search_limit', 25 );
      
  if (is_array( $areas )) {
         if (!array_intersect( $areas, array_keys($this->onContentSearchAreas() ) )) {
              return array();
         }
  }
 
  if ($text == '') {
    return array();
  }
  $text = trim( $text );
  $text = $database->Quote( '%'.$database->getEscaped( $text, true ).'%', false );

  switch ( $ordering ){
        case 'oldest':
            $order = 'a.date_added ASC';
            break;

        case 'popular':
            $order = 'a.downloads DESC';
            break;

        case 'alpha':
            $order = 'a.file_title ASC';
            break;

        case 'category':
            $order = 'b.cat_title ASC, a.file_title ASC';
            break;

        case 'newest':
        default:
            $order = 'a.date_added DESC';
  }
    
    // get published root menu link
    $database->setQuery("SELECT id from #__menu WHERE link = 'index.php?option=com_jdownloads&view=viewcategories' and published = 1");
    $root_itemid = $database->loadResult();
    
    // get groups access
    if ($user->id > 0){
        $user_is_in_groups = getUserGroups();
    } else {
        $user_is_in_groups = 0;
    } 
    
    $where = '';
    $user_groups = '';
    
    if ($user_is_in_groups) $user_groups = "OR cat_group_access IN ($user_is_in_groups)"; 
  
  $query = 'SELECT a.cat_id, a.published, a.file_title AS title, a.date_added AS created,'
    . ' CONCAT(a.description, a.description_long) AS text,'
    . ' b.cat_title AS section, b.cat_alias,';
    if ($sef){
        $query .= ' CONCAT("index.php?option=com_jdownloads&Itemid=&view=viewdownload&cid=",file_id,":",file_alias) AS href,';
    } else {
        $query .= ' CONCAT("index.php?option=com_jdownloads&Itemid=&view=viewdownload&cid=",file_id) AS href,';
    }    
    $query .= ' "2" AS browsernav'
    . ' FROM #__jdownloads_files AS a'
    . ' LEFT JOIN #__jdownloads_cats AS b ON b.cat_id = a.cat_id'
    . ' WHERE ('
    . ' a.file_title LIKE '.$text
    . ' OR a.description LIKE '.$text
    . ' OR a.description_long LIKE '.$text
    . ' OR a.date_added LIKE '.$text
    . ' OR a.author LIKE '.$text.')'
    . ' AND a.published = 1'
    . ' AND b.published = 1'
    . ' AND (b.cat_access <= '.$user_access.' '.$user_groups.')'
    . ' ORDER BY '. $order
    . ' LIMIT '. $limit;    
    
  $database->setQuery( $query );
  $files = $database->loadObjectList();
  if ($files){
     foreach ($files as $file){
            $database->setQuery("SELECT id from #__menu WHERE link = 'index.php?option=com_jdownloads&view=viewcategory&catid=".$file->cat_id."' and published = 1");
            $Itemid = $database->loadResult();
            if (!$Itemid){
                $Itemid = $root_itemid;
            } 
             if ($sef){
                $file->href = str_replace('&cid=', '&catid='.$file->cat_id.':'.$file->cat_alias.'&cid=', $file->href);
                $file->href = str_replace('&Itemid=', '&Itemid='.$Itemid, $file->href); 
             } else {
                $file->href = str_replace('&cid=', '&catid='.$file->cat_id.'&cid=', $file->href);
                $file->href = str_replace('&Itemid=', '&Itemid='.$Itemid, $file->href);                 
             }    
     }    
  }         
  return $files;
}

}

function getUserGroups(){
    $database = &JFactory::getDBO();
    $user = &JFactory::getUser();
    $group_list = array();
    $user_in_groups = array();
    $database->setQuery("SELECT id, groups_members FROM #__jdownloads_groups");
    $all_groups = $database->loadObjectList();
    if (count($all_groups > 0)){
        foreach ($all_groups as $group){
                 $group_list = explode(',', $group->groups_members);
                 if (in_array($user->id, $group_list)){
                     $user_in_groups[] = $group->id;
                 }    
        }    
    }    
    if (count($user_in_groups) > 1){
       $user_in_groups = implode(',', $user_in_groups);
    } else {
       $user_in_groups = $user_in_groups[0];
    }     
    return $user_in_groups;
}

function checkAccess(){
    
    // special user group:
    // 3 = author
    // 4 = editor
    // 5 = publisher
    // 6 = manager
    // 7 = admin
    // 8 = super admin - super user
    
    $user = &JFactory::getUser();
    $coreUserGroups = $user->getAuthorisedGroups();
    // $coreViewLevels = $user->getAuthorisedViewLevels();
    $aid = max ($user->getAuthorisedViewLevels());
    
    $access = '';
    if ($aid == 1) $access = '02'; // public
    if ($aid == 2 || $aid > 3) $access = '11'; // regged or member from custom joomla group
    if ($aid == 3 || in_array(3,$coreUserGroups) || in_array(4,$coreUserGroups) || in_array(5,$coreUserGroups) || in_array(6,$coreUserGroups)) $access = '22'; // special user
    if (in_array(8,$coreUserGroups) || in_array(7,$coreUserGroups)){
        // is admin or super user
        $access = '99';
    }
    return $access;
}
