<?php
  /**
   * jdownloads_search 1.5.2
   *
   * jDownloads search plugin for jD 1.5
   * by arno Betz www.jDownloads.com
   */
 

defined( '_JEXEC' ) or die( 'Restricted access' );
Error_Reporting(E_ERROR);

$mainframe->registerEvent( 'onSearch', 'Searchjdownloads' );
$mainframe->registerEvent( 'onSearchAreas', 'SearchjdownloadsAreas' ); 
jimport( 'joomla.plugin.plugin' ); 
 
Function SearchjdownloadsAreas() { 
     static $areas = array( 
        'jdownloads_search' => 'Downloads' 
     ); 
     return $areas; 
}

function Searchjdownloads($text, $phr='', $order='', $areas=null){

  $user = &JFactory::getUser();
  $database = &JFactory::getDBO();
  $plugin =& JPluginHelper::getPlugin('search', 'jdownloads_search');
  $params = new JParameter( $plugin->params );
  $limit  = $params->get( 'search_limit', 25 );
      
  if (is_array( $areas )) {
         if (!array_intersect( $areas, array_keys( SearchjdownloadsAreas() ) )) {
              return array();
         }
  }
 
  if ($text == '') {
    return array();
  }
  $text = trim( $text );
  $text = $database->Quote( '%'.$database->getEscaped( $text, true ).'%', false );

  switch ( $ordering ){
        case 'oldest':
            $order = 'a.date_added ASC';
            break;

        case 'popular':
            $order = 'a.downloads DESC';
            break;

        case 'alpha':
            $order = 'a.file_title ASC';
            break;

        case 'category':
            $order = 'b.cat_title ASC, a.file_title ASC';
            break;

        case 'newest':
        default:
            $order = 'a.date_added DESC';
  }
    
    // get published root menu link
    $database->setQuery("SELECT id from #__menu WHERE link = 'index.php?option=com_jdownloads&view=viewcategories' and published = 1");
    $root_itemid = $database->loadResult();
    
    $access = '';
    if ($user->aid == 0) $access = '01';
    if ($user->aid == 1) $access = '11';
    if ($user->aid == 2) $access = '22';
    // admins has access to all categories
    if ($user->usertype == 'Super Administrator' || $user->usertype == 'Administrator'){
        $access = '99';
    }
    
        // get groups access
    if ($user->id > 0){
        $user_is_in_groups = getUserGroups();
    } else {
        $user_is_in_groups = 0;
    } 
    
    $where = '';
    $user_groups = '';
    
    if ($user_is_in_groups) $user_groups = "OR cat_group_access IN ($user_is_in_groups)"; 
  
  $query = 'SELECT a.cat_id, a.published, a.file_title AS title, a.date_added AS created,'
    . ' CONCAT(a.description, a.description_long) AS text,'
    . ' b.cat_title AS section,'
    . ' CONCAT("index.php?option=com_jdownloads&Itemid=&view=viewdownload&cid=",file_id) AS href,'
    . ' "2" AS browsernav'
    . ' FROM #__jdownloads_files AS a'
    . ' LEFT JOIN #__jdownloads_cats AS b ON b.cat_id = a.cat_id'
    . ' WHERE ('
    . ' a.file_title LIKE '.$text
    . ' OR a.description LIKE '.$text
    . ' OR a.description_long LIKE '.$text
    . ' OR a.author LIKE '.$text.')'
    . ' AND a.published = 1'
    . ' AND b.published = 1'
    . ' AND (b.cat_access <= '.$access.' '.$user_groups.')'
    . ' ORDER BY '. $order
    . ' LIMIT '. $limit;    
    
  $database->setQuery( $query );
  $files = $database->loadObjectList();
  if ($files){
     foreach ($files as $file){
            $database->setQuery("SELECT id from #__menu WHERE link = 'index.php?option=com_jdownloads&view=viewcategory&catid=".$file->cat_id."' and published = 1");
            $Itemid = $database->loadResult();
            if (!$Itemid){
                $Itemid = $root_itemid;
            } 
             $file->href = str_replace('&cid=', '&catid='.$file->cat_id.'&cid=', $file->href);
             $file->href = str_replace('&Itemid=', '&Itemid='.$Itemid, $file->href); 
     }    
  }         
  return $files;
}

function getUserGroups(){
    $database = &JFactory::getDBO();
    $user = &JFactory::getUser();
    $group_list = array();
    $user_in_groups = array();
    $database->setQuery("SELECT id, groups_members FROM #__jdownloads_groups");
    $all_groups = $database->loadObjectList();
    if (count($all_groups > 0)){
        foreach ($all_groups as $group){
                 $group_list = explode(',', $group->groups_members);
                 if (in_array($user->id, $group_list)){
                     $user_in_groups[] = $group->id;
                 }    
        }    
    }    
    if (count($user_in_groups) > 1){
       $user_in_groups = implode(',', $user_in_groups);
    } else {
       $user_in_groups = $user_in_groups[0];
    }     
    return $user_in_groups;
}
?>