<?php
/**
 * jDownloads Categories - shows categories list from the component jDownloads
 *
 * @version 1.0
 * @author smart (smart@joomlatune.ru)
 * @copyright (C) 2009 by smart (http://www.joomlatune.ru)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * Modified by Arno Betz for jDownloads 1.7 or newer
 **/
 
// ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Restricted access' );

if (!function_exists('jdownloads_cats_build_html')) { 
	function jdownloads_cats_build_html( $id, $html, $children, $Itemid, $active, $level = 0, $maxlevel = 9999) {
		if (isset($children[$id]) && $level <= $maxlevel) {
			foreach ($children[$id] as $v) {
				$link = JRoute::_('index.php?option=com_jdownloads&amp;Itemid='.$Itemid.'&amp;view=viewcategory&catid=' . $v->id);
				$html .= '<li>';
				if ($v->id == $active) {
					$html .= '<span class="active">' . $v->title . '</span>';
				} else {
					$html .= '<a href="' . $link . '" title="' . $v->title . '">' . $v->title . '</a>';
				}
				$nested_html = jdownloads_cats_build_html($v->id, '', $children, $Itemid, $active, $level + 1);
				if ($nested_html != '') {
					$html .= '<ul>' . $nested_html . '</ul>';
				}
				$html .= '</li>';
			}
		}
		return $html;
	}
}

$user = &JFactory::getUser();
$dbo = & JFactory::getDBO();
$document =& JFactory::getDocument();
$mainframe->addCustomHeadTag( "<link href=\"".JURI::base()."modules/mod_jdownloads_cats/mod_jdownloads_cats.css\" rel=\"stylesheet\" type=\"text/css\" media=\"screen\"/>" );
$option = JRequest::getCmd('option');
$catid = JRequest::getVar( 'catid', -1, '', 'int' );
$dbo->setQuery("SELECT id from #__menu WHERE link = 'index.php?option=com_jdownloads' and published = 1");
if (!$Itemid = $dbo->loadResult()){
        $dbo->setQuery("SELECT id from #__menu WHERE link = 'index.php?option=com_jdownloads&view=viewcategories' and published = 1");
        $Itemid = $dbo->loadResult();
}
if (!$Itemid){
    $dbo->setQuery("SELECT id from #__menu WHERE link = 'index.php?option=com_jdownloads&view=viewcategory&catid=".$files[$i]->cat_id."' and published = 1");
    $Itemid = $dbo->loadResult();
}
if (!$Itemid) $Itemid = 0;        

if ($option != 'com_jdownloads') {
	$catid = -1;
}

$groups_exists = false;
$prefix = $dbo->_table_prefix;
$tables = array( $prefix.'jdownloads_cats' );
$result = $dbo->getTableFields( $tables );
if ($result[$prefix.'jdownloads_cats']['cat_group_access']) $groups_exists = true;

$access = '';
switch($user->aid) {
	case 0:
		$access = '01';
		break;
	case 1:
		$access = '11';
		break;
	case 2:
		$access = '22';
		break;
	default:
		$access = '';
}

// get cat access groups
    if ($user->id){
        $dbo->setQuery("SELECT id FROM #__jdownloads_groups WHERE FIND_IN_SET($user->id, groups_members)");
        $in_groups = implode(',', $dbo->loadResultArray());           
    } 
    if (!$in_groups) $in_groups = 999999;
    
if ($groups_exists){
    $dbo->setQuery("SELECT cat_id as id, cat_title as title, parent_id as parent FROM #__jdownloads_cats WHERE published = 1 AND (cat_access <= '$access' OR cat_group_access IN ($in_groups)) ORDER BY parent_id, ordering");
} else {    
    $dbo->setQuery("SELECT cat_id as id, cat_title as title, parent_id as parent FROM #__jdownloads_cats WHERE published = 1 AND cat_access <= '$access' ORDER BY parent_id, ordering");
}    
$cats = $dbo->loadObjectList();

$html = '<ul class="jd_categories' . $params->get('moduleclass_sfx') . '">';
    
if (count($cats)) {
	$children = array();
	foreach ($cats as $v) {
		$pt = $v->parent;
		$list = isset($children[$pt]) ? $children[$pt] : array();
		array_push($list, $v);
		$children[$pt] = $list;
	}
	$html .= jdownloads_cats_build_html(0, '', $children, $Itemid, $catid);
}

$html .= '</ul>';

echo $html; 
?>